'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var createSchema = require('json-gate').createSchema;

var Schemas = function () {
  function Schemas() {
    _classCallCheck(this, Schemas);

    this.map = new Map();
  }

  _createClass(Schemas, [{
    key: 'load',
    value: function load(schemas) {
      var _this = this;

      Object.keys(schemas).forEach(function (name) {
        var doc = schemas[name];['input', 'output'].forEach(function (type) {
          if (doc.hasOwnProperty(type)) {
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
              for (var _iterator = Object.keys(doc[type])[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var command = _step.value;

                var schema = createSchema(doc[type][command]);
                doc[type][command].__validate = schema.validate;
              }
            } catch (err) {
              _didIteratorError = true;
              _iteratorError = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }
              } finally {
                if (_didIteratorError) {
                  throw _iteratorError;
                }
              }
            }
          }
        });
        _this.map.set(name, doc);
      });
    }
  }, {
    key: 'has',
    value: function has(it) {
      return this.map.has(it);
    }
  }, {
    key: 'get',
    value: function get(it) {
      return this.map.get(it);
    }
  }, {
    key: 'validate',
    value: function validate(type, protocol, command, data) {
      if (!this.map.get(protocol) || !this.map.get(protocol).hasOwnProperty(type) || !this.map.get(protocol)[type].hasOwnProperty(command)) {
        return Error('Unknown protocol message: ' + protocol + ':' + command);
      }

      try {
        this.map.get(protocol)[type][command].__validate(data);
        return true;
      } catch (e) {
        return e;
      }
    }
  }]);

  return Schemas;
}();

module.exports = Schemas;