'use strict';

/* global console */

// TODO: same as used in chix-runtime

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EventEmitter = require('events');

function nop() {
  return;
}

function NopLogger() {
  this.info = nop;
  this.warn = nop;
  this.debug = nop;
  this.error = nop;
  this.addLevel = nop;
}

/**
 *
 * Core object
 *
 * Mainly used for a consistent logging interface
 *
 */

var Core = function (_EventEmitter) {
  _inherits(Core, _EventEmitter);

  function Core(options) {
    _classCallCheck(this, Core);

    options = options || {};

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Core).call(this, options));

    _this.options = options;

    if (_this.options.logger) {
      if (_this.options.logger.constructor.name === 'Console') {
        _this.logger = Object.create(console);
        _this.logger.debug = _this.logger.log;
        _this.logger.addLevel = nop;
      } else {
        _this.logger = _this.options.logger;
      }
    } else {
      _this.logger = new NopLogger();
    }
    return _this;
  }

  return Core;
}(EventEmitter);

module.exports = Core;