'use strict';

/* global chrome */

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseTransport = require('./base');

/**
*
* Chrome Transport
*
* To be used within content scripts
*
*/

var ChromeTransport = function (_BaseTransport) {
  _inherits(ChromeTransport, _BaseTransport);

  function ChromeTransport(options) {
    _classCallCheck(this, ChromeTransport);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ChromeTransport).call(this, options));

    var self = _this;

    _this.connected = false;

    options.protocol = options.protocol || 'noflo';

    _this.options = options;

    _this.logger.info('windowTransport', 'Connected');

    _this.connected = true;
    _this.emit('connected');

    _this.port = chrome.runtime.connect();

    // The listening part
    window.addEventListener('message', function (event) {
      /*
       if (event.source !== window) {
       return
       }
       */

      if (event.type === 'message' && event.data.protocol && event.data.command) {
        if (!self.isRegistered(event.source)) {
          self.register(event.source);
        }
        self.receive(event.data, event.source);
      }
    });
    return _this;
  }

  /**
   *
   * Send the response.
   *
   */


  _createClass(ChromeTransport, [{
    key: '$send',
    value: function $send(data /* , conn */) {
      this.setSecret(data);
      this.port.postMessage(data);
      // else {
      //  this.logger.warn('ChromeTransport:', 'connection already closed')
    }
  }]);

  return ChromeTransport;
}(BaseTransport);

module.exports = ChromeTransport;