'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseTransport = require('./base');

/**
*
* Dummy Transport
*
* Used for testing.
*
* Use the emit method to trigger receives.
*
* Usage:
*
* var transport = DummyTransport()
*
* transport.emit('network',{
*  protocol: 'network'
*  command: 'start',
*  payload: ...,
* }, {
*
*   connection: ... intercept.
*
* })
*
* @params {Object} options Options
*/

var DummyTransport = function (_BaseTransport) {
  _inherits(DummyTransport, _BaseTransport);

  function DummyTransport() {
    _classCallCheck(this, DummyTransport);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(DummyTransport).apply(this, arguments));
  }

  _createClass(DummyTransport, [{
    key: '$send',
    value: function $send(data, conn) {
      this.setSecret(data);
      this.emit('send', data, conn);

      // always listening for e.g. `network:start`
      this.emit(data.protocol + ':' + data.command, data, conn);
    }
  }]);

  return DummyTransport;
}(BaseTransport);

module.exports = DummyTransport;