'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseTransport = require('./base');

/**
*
* Window Transport
*
*/

var WindowTransport = function (_BaseTransport) {
  _inherits(WindowTransport, _BaseTransport);

  function WindowTransport(options) {
    _classCallCheck(this, WindowTransport);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(WindowTransport).call(this, options));

    var self = _this;

    _this.connected = false;

    options.protocol = options.protocol || 'noflo';

    _this.options = options;

    _this.logger.info('windowTransport', 'Connected');

    _this.connected = true;
    _this.emit('connected');

    // The listening part
    window.addEventListener('message', function (event) {
      /*
       if (event.source !== window) {
       return
       }
       */

      // so send has easy access to the origin.
      event.source.origin = event.origin;

      if (event.type === 'message' && event.data.protocol && event.data.command) {
        if (!self.isRegistered(event.source)) {
          self.register(event.source);
        }
        self.receive(event.data, event.source);
      }
    });

    /* TODO: handle error and disconnect (if possible)
     conn.onerror = function(error) {
     self.logger.error('wsClient', 'Connection Error: ',  error)
     }
      conn.onclose = function(event) {
     self.logger.info('wsClient', 'connection close', event.data)
     self.connected = false
     self.emit('disconnected')
      // self.unregister(conn)
     }
     */
    return _this;
  }

  /**
   *
   * Send the response.
   *
   */


  _createClass(WindowTransport, [{
    key: '$send',
    value: function $send(data, conn) {
      this.setSecret(data);
      // TODO: for now just sends to all
      conn.postMessage(data, conn.origin);
      // else {
      //  this.logger.warn('WindowTransport:', 'connection already closed')
    }
  }]);

  return WindowTransport;
}(BaseTransport);

module.exports = WindowTransport;