'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _s = require('underscore.string');
var render = require('prettyjson').render;
require('colors');

var host = 'Flowhub';

// order of appearance
var order = ['graph', 'id', 'name', 'component', 'library', 'main'];

exports.printmsg = function printmsg(logger, data, dir, client) {
  var key = void 0;
  var pp = {};
  var s = [];

  for (key in data.payload) {
    if (data.payload.hasOwnProperty(key)) {
      // what to pp
      if (_typeof(data.payload[key]) === 'object') {
        //  if (Object.keys(data.payload[key]).length > 0) {
        pp[key] = data.payload[key];
        //  }
        // larger text pp
      } else if (data.payload[key].length > 36) {
        pp[key] = data.payload[key];
      } else {
        // on the same line
        s.push({ name: key, value: data.payload[key] });
      }
    }
  }

  s.sort(function (a, b) {
    var posA = order.indexOf(a.name);
    var posB = order.indexOf(b.name);
    return posA < posB || posB === -1 ? -1 : 1;
  });

  var d = [];
  s.forEach(function (x) {
    d.push(_s.rpad(x.name.bold.green + ': ' + x.value, 30));
  });

  var extra = render(pp);
  extra = '\n' + extra || '';
  extra = extra.replace(/\n/gm, '\n' + _s.repeat(' ', 38));

  if (data.protocol === 'component' && (data.command === 'component' || data.command === 'source')) {
    // be a bit more silent for component
    extra = '';
  }

  logger.debug(host, '%s %s %s | %s %s', dir.blue, _s.lpad(client.bold, 16), _s.rpad(data.protocol.blue + ':' + data.command.cyan, 20), d.join(' '), extra);
};