'use strict'

const createSchema = require('json-gate').createSchema

class Schemas {
  constructor () {
    this.map = new Map()
  }
  load (schemas) {
    Object.keys(schemas).forEach((name) => {
      const doc = schemas[name]
      ;['input', 'output'].forEach((type) => {
        if (doc.hasOwnProperty(type)) {
          for (const command of Object.keys(doc[type])) {
            const schema = createSchema(
              doc[type][command]
            )
            doc[type][command].__validate = schema.validate
          }
        }
      })
      this.map.set(name, doc)
    })
  }

  has (it) {
    return this.map.has(it)
  }

  get (it) {
    return this.map.get(it)
  }

  validate (type, protocol, command, data) {
    if (!this.map.get(protocol) ||
      !this.map.get(protocol).hasOwnProperty(type) ||
      !this.map.get(protocol)[type].hasOwnProperty(command)) {
      return Error('Unknown protocol message: ' + protocol + ':' + command)
    }

    try {
      this.map.get(protocol)[type][command].__validate(data)
      return true
    } catch (e) {
      return e
    }
  }
}

module.exports = Schemas
