'use strict'

/* global console */

// TODO: same as used in chix-runtime
const EventEmitter = require('events')

function nop () {
  return
}

function NopLogger () {
  this.info = nop
  this.warn = nop
  this.debug = nop
  this.error = nop
  this.addLevel = nop
}

/**
 *
 * Core object
 *
 * Mainly used for a consistent logging interface
 *
 */
class Core extends EventEmitter {
  constructor (options) {
    options = options || {}
    super(options)

    this.options = options

    if (this.options.logger) {
      if (this.options.logger.constructor.name === 'Console') {
        this.logger = Object.create(console)
        this.logger.debug = this.logger.log
        this.logger.addLevel = nop
      } else {
        this.logger = this.options.logger
      }
    } else {
      this.logger = new NopLogger()
    }
  }
}

module.exports = Core
