'use strict'

/* global chrome */

const BaseTransport = require('./base')

/**
*
* Chrome Transport
*
* To be used within content scripts
*
*/

class ChromeTransport extends BaseTransport {
  constructor (options) {
    super(options)

    const self = this

    this.connected = false

    options.protocol = options.protocol || 'noflo'

    this.options = options

    this.logger.info('windowTransport', 'Connected')

    this.connected = true
    this.emit('connected')

    this.port = chrome.runtime.connect()

    // The listening part
    window.addEventListener('message', function (event) {
      /*
       if (event.source !== window) {
       return
       }
       */

      if (event.type === 'message' &&
        event.data.protocol && event.data.command) {
        if (!self.isRegistered(event.source)) {
          self.register(event.source)
        }
        self.receive(event.data, event.source)
      }
    })
  }

  /**
   *
   * Send the response.
   *
   */
  $send (data /* , conn */) {
    this.setSecret(data)
    this.port.postMessage(data)
  // else {
  //  this.logger.warn('ChromeTransport:', 'connection already closed')
  }
}

module.exports = ChromeTransport
