'use strict'

const BaseTransport = require('./base')

/**
*
* Dummy Transport
*
* Used for testing.
*
* Use the emit method to trigger receives.
*
* Usage:
*
* var transport = DummyTransport()
*
* transport.emit('network',{
*  protocol: 'network'
*  command: 'start',
*  payload: ...,
* }, {
*
*   connection: ... intercept.
*
* })
*
* @params {Object} options Options
*/
class DummyTransport extends BaseTransport {
  $send (data, conn) {
    this.setSecret(data)
    this.emit('send', data, conn)

    // always listening for e.g. `network:start`
    this.emit(data.protocol + ':' + data.command, data, conn)
  }
}

module.exports = DummyTransport
