'use strict'

const BaseTransport = require('./base')

/**
*
* Window Transport
*
*/
class WindowTransport extends BaseTransport {
  constructor (options) {
    super(options)

    const self = this

    this.connected = false

    options.protocol = options.protocol || 'noflo'

    this.options = options

    this.logger.info('windowTransport', 'Connected')

    this.connected = true
    this.emit('connected')

    // The listening part
    window.addEventListener('message', function (event) {
      /*
       if (event.source !== window) {
       return
       }
       */

      // so send has easy access to the origin.
      event.source.origin = event.origin

      if (event.type === 'message' &&
        event.data.protocol && event.data.command) {
        if (!self.isRegistered(event.source)) {
          self.register(event.source)
        }
        self.receive(event.data, event.source)
      }
    })

  /* TODO: handle error and disconnect (if possible)
   conn.onerror = function(error) {
   self.logger.error('wsClient', 'Connection Error: ',  error)
   }

   conn.onclose = function(event) {
   self.logger.info('wsClient', 'connection close', event.data)
   self.connected = false
   self.emit('disconnected')

   // self.unregister(conn)
   }
   */
  }

  /**
   *
   * Send the response.
   *
   */
  $send (data, conn) {
    this.setSecret(data)
    // TODO: for now just sends to all
    conn.postMessage(data, conn.origin)
  // else {
  //  this.logger.warn('WindowTransport:', 'connection already closed')
  }
}

module.exports = WindowTransport
