'use strict'

const _s = require('underscore.string')
const render = require('prettyjson').render
require('colors')

const host = 'Flowhub'

// order of appearance
const order = [
  'graph',
  'id',
  'name',
  'component',
  'library',
  'main'
]

exports.printmsg = function printmsg (logger, data, dir, client) {
  let key
  const pp = {}
  const s = []

  for (key in data.payload) {
    if (data.payload.hasOwnProperty(key)) {
      // what to pp
      if (typeof data.payload[key] === 'object') {
        //  if (Object.keys(data.payload[key]).length > 0) {
        pp[key] = data.payload[key]
        //  }
        // larger text pp
      } else if (data.payload[key].length > 36) {
        pp[key] = data.payload[key]
      } else {
        // on the same line
        s.push({name: key, value: data.payload[key]})
      }
    }
  }

  s.sort(function (a, b) {
    const posA = order.indexOf(a.name)
    const posB = order.indexOf(b.name)
    return (posA < posB || posB === -1) ? -1 : 1
  })

  const d = []
  s.forEach(function (x) {
    d.push(
      _s.rpad(x.name.bold.green + ': ' + x.value, 30)
    )
  })

  let extra = render(pp)
  extra = '\n' + extra || ''
  extra = extra.replace(/\n/gm, '\n' + _s.repeat(' ', 38))

  if (data.protocol === 'component' && (data.command === 'component' || data.command === 'source')) {
    // be a bit more silent for component
    extra = ''
  }

  logger.debug(
    host, '%s %s %s | %s %s',
    dir.blue, _s.lpad(client.bold, 16),
    _s.rpad(data.protocol.blue + ':' + data.command.cyan, 20), d.join(' '),
    extra
  )
}

