'use strict'

const glob = require('glob')
const yaml = require('js-yaml')
const fs = require('fs')
const path = require('path')

exports.loadSchemas = function loadSchemas (schemaPattern) {
  const files = glob.sync(schemaPattern)
  const schemas = {}
  files.forEach((file) => {
    const name = path.basename(file, '.yml')
    const doc = yaml.safeLoad(
      fs.readFileSync(file, 'utf8')
    )
    schemas[name] = doc
  })
  return schemas
}
